<!DOCTYPE html>
<html lang="en">
<head>
    <style>
        body {
            display: flex;
            align-items: center;
            height: 100vh;
            justify-items: center;
            overflow: hidden;
        }

        .table-outlet {
            display: flex;
            flex-flow: column;
            max-height: 60vh;
            width: 100%;
            overflow: auto;
        }

        tr {
            vertical-align: top;
        }

        .results-table-header {
            position: sticky;
            top: 0;
            background-color: white;
        }

        .is-hidden {
            display: none;
        }
    </style>

    <!-- Bootstrap CSS -->
    <meta charset="utf-8"/>
    <meta content="width=device-width, initial-scale=1" name="viewport"/>
    <link
            crossorigin="anonymous"
            href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css"
            integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC"
            rel="stylesheet"
    />

    <title>Searcher</title>
</head>
<body>
<div class="container">
    <div class="mb-3">
        <form onsubmit="fetchResults(event)">
            <input
                    class="form-control"
                    id="search-input"
                    placeholder="Enter search query"
                    type="text"
            />
            <div class="alert alert-danger is-hidden" id="error-outlet" role="alert"></div>
        </form>
    </div>

    <div class="alert alert-info is-hidden text-center" id="empty-result-outlet" role="alert"></div>

    <div class="table-outlet is-hidden" id="results-table-outlet">
        <table class="table">
            <thead class="results-table-header sticky-top">
            <tr class="table-dark">
                <th>FileName</th>
                <th>Intervals</th>
            </tr>
            </thead>
            <tbody id="results-table"></tbody>
        </table>
    </div>
</div>

<script
        crossorigin="anonymous"
        integrity="sha384-U1DAWAznBHeqEIlVSCgzq+c9gqGAJn5c/t99JyeKa9xxaYpSvHU5awsuZVVFIhvj"
        src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/js/bootstrap.bundle.min.js"
></script>

<script>
    const RESULTS_TABLE_OUTLET = document.getElementById("results-table-outlet");
    const RESULTS_TABLE = document.getElementById("results-table");
    const SEARCH_INPUT = document.getElementById("search-input");
    const ERROR_OUTLET = document.getElementById("error-outlet");
    const EMPTY_RESULT_OUTLET = document.getElementById("empty-result-outlet");

    function renderResults(results) {
        if (!results.length) {
            EMPTY_RESULT_OUTLET.classList.remove('is-hidden');
            EMPTY_RESULT_OUTLET.textContent = "A thorough search was carried out. Sorry, no results have been found for your query.";
            return
        }

        RESULTS_TABLE_OUTLET.classList.remove('is-hidden');
        RESULTS_TABLE.innerHTML = results
            .map(({matches, file}) => {
                const items = Array.from(Object.entries(matches));
                return {
                    file,
                    items,
                    total: items.length,
                };
            })
            .map((el) =>
                el.items.map((item, index) => mapResultToTableRow(item, index, el))
            )
            .flat()
            .join("");
    }

    function mapResultToTableRow([query, intervals], index, {total, file}) {
        const intervalText = intervals.map(({start, end}) => `[${start}, ${end}]`).join(", ")
        const content = `<td>${query}: ${intervalText}</td>`;

        let title = "";
        if (!index) {
            title = `<td rowspan="${total}">${file}</td>`;
        }
        return `<tr>${title}${content}</tr>`;
    }

    async function fetchResults(e) {
        e.preventDefault();
        const query = SEARCH_INPUT.value;
        try {
            clearOutlets();
            const resp = await fetch(
                `http://localhost:50100/search?query=${query}`
            )
                .then(async (response) => {
                    if (!response.ok) {
                        throw await response.json();
                    }
                    return response;
                })
                .then((response) => response.json())
                .catch(e => {
                    ERROR_OUTLET.classList.remove('is-hidden');
                    ERROR_OUTLET.textContent = e?.errorMessage ?? "Unhandled error";
                });
            renderResults(resp.files);
        } catch (e) {
            console.error(e);
        }
    }

    function clearOutlets() {
        ERROR_OUTLET.classList.add('is-hidden');
        ERROR_OUTLET.textContent = '';
        EMPTY_RESULT_OUTLET.classList.add('is-hidden');
        EMPTY_RESULT_OUTLET.textContent = '';
        RESULTS_TABLE.innerHTML = '';
        RESULTS_TABLE_OUTLET.classList.add('is-hidden')
    }
</script>
</body>
</html>